Ogre::RTShader::ProgramWriter Class Reference
RTShader

Base class interface for shader program writers. More...

`#include <OgreShaderProgramWriter.h>`

Inheritance diagram for Ogre::RTShader::ProgramWriter:
[legend]

List of all members.

## Public Member Functions

virtual | ~ProgramWriter ()
| Class destructor.
virtual void | writeSourceCode (StringSerialiser &os, Program *program)=0
| Write the program shader source code.
virtual const String & | getTargetLanguage () const =0
| Return the target language of this writer.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)

## Protected Member Functions

void | writeProgramTitle (StringSerialiser &os, Program *program)
| Write the program title.
void | writeUniformParametersTitle (StringSerialiser &os, Program *program)
| Write the uniform parameters title.
void | writeFunctionTitle (StringSerialiser &os, Function *function)
| Write a function title.

## Detailed Description

Base class interface for shader program writers.

The main usage of this class is to generate a shader source code from the given CPU program. In order to support specific shader language one should subclass this interface and implement the pure methods.

Definition at line 56 of file OgreShaderProgramWriter.h.

## Constructor & Destructor Documentation

virtual Ogre::RTShader::ProgramWriter::~ProgramWriter | ( |  | ) | `[virtual]`

Class destructor.

Definition at line 62 of file OgreShaderProgramWriter.h.

## Member Function Documentation

virtual const String& Ogre::RTShader::ProgramWriter::getTargetLanguage | ( |  | ) | const`[pure virtual]`

Return the target language of this writer.

Implemented in Ogre::RTShader::GLSLESProgramWriter, Ogre::RTShader::CGProgramWriter, Ogre::RTShader::HLSLProgramWriter, and Ogre::RTShader::GLSLProgramWriter.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

void Ogre::RTShader::ProgramWriter::writeFunctionTitle | ( | StringSerialiser & | os,
|  | Function * | function
| ) |  | `[protected]`

Write a function title.

void Ogre::RTShader::ProgramWriter::writeProgramTitle | ( | StringSerialiser & | os,
|  | Program * | program
| ) |  | `[protected]`

Write the program title.

virtual void Ogre::RTShader::ProgramWriter::writeSourceCode | ( | StringSerialiser & | os,
|  | Program * | program
| ) |  | `[pure virtual]`

Write the program shader source code.

Parameters:

  os | The output stream to write to code into.
  program | The source CPU program for the GPU program code.

Implemented in Ogre::RTShader::GLSLESProgramWriter.

void Ogre::RTShader::ProgramWriter::writeUniformParametersTitle | ( | StringSerialiser & | os,
|  | Program * | program
| ) |  | `[protected]`

Write the uniform parameters title.

The documentation for this class was generated from the following file:

- OgreShaderProgramWriter.h

Copyright © 2012 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Sun Sep 2 2012 07:28:07